#ifndef	SUP_H
#define SUP_H


#define		PSI_VENDOR_ID						0x0A2F

//#define		BULK_TRANS_MAX						65536
#define		BULK_TRANS_MAX						1048576
#define		USB_TIME_OUT						5000

//  ظĺ
#define     SUP_VENDER_REQUEST_REGISTER     	0xB0
#define     SUP_VENDER_REQUEST_DATA         	0xB1
#define     SUP_VENDER_REQUEST_USBCONFIG    	0xB2
#define     SUP_VENDER_REQUEST_BOARDINFO    	0xB3
#define     SUP_VENDER_REQUEST_GPIODIR      	0xB4
#define     SUP_VENDER_REQUEST_GPIOWRITE    	0xB5
#define     SUP_VENDER_REQUEST_GPIOREAD     	0xB6
#define     SUP_VENDER_REQUEST_GPIFWAIT     	0xB7
#define     SUP_VENDER_REQUEST_GPIFWAVE     	0xB8
#define     SUP_VENDER_REQUEST_GPIFCLK      	0xB9
#define     SUP_VENDER_REQUEST_GPIFFLAG     	0xBA
#define     SUP_VENDER_REQUEST_8051CORE     	0xBB
#define     SUP_VENDER_REQUEST_I2CWRITE     	0xC0
#define     SUP_VENDER_REQUEST_I2CREAD      	0xC1
#define     SUP_VENDER_REQUEST_GETTEMP      	0xC2
#define     SUP_VENDER_REQUEST_WAVECHANGE    	0xC3
#define     SUP_VENDER_REQUEST_SUSPEND      	0xC4
#define     SUP_VENDER_REQUEST_REGISTER_EX    	0xC6

//  ظĺ(Smart-IO2p)
#define     SUP_VENDER_REQUEST_REG_WRITE_EXIO2  	0xB1
#define     SUP_VENDER_REQUEST_REG_BURST_WRITE  	0xB2


//  USB̨޺޺
#define     SUP_USBCONFIG_START             	0xC1
#define     SUP_USBCONFIG_END               	0x41
#define     SUP_DONE_WAIT_SIZE              	65536
#define     SUP_CFG_STS_ADRS				    2
#define     SUP_CFG_STATUS_SUCCESS				0
#define		SUPlv_CFG_MODE_REG_ADRS				63
#define		SUPlv_CFG_MODE_INT					0x00
#define		SUPlv_CFG_MODE_EXT					0x01

//  ް]޺
#define     SUP_DATA_TRANS_OUT_START        	0xC0
#define     SUP_DATA_TRANS_OUT_END          	0x40
#define     SUP_DATA_TRANS_IN_START         	0x80
#define     SUP_DATA_TRANS_IN_END           	0x00

#define     SUP_CONFIG_MODE_INTEL	          	0
#define     SUP_CONFIG_MODE_XILINX          	1

//  ظ(B3h) ްޏ擾ނ̎擾I
#define     SUP_BOARDINFO_FIRMID            	0x00C0
#define     SUP_BOARDINFO_CHIPVER           	0x0080
#define     SUP_BOARDINFO_PID               	0x0040
#define     SUP_BOARDINFO_SPEED             	0x0000
#define     SUP_FULL_SPEED                  	0x0000
#define     SUP_HIGH_SPEED                  	0x0080

//	GPIFؓ]ӰޗpҰ
#define		SUPlv_GPIFWAVE_DIR_READ				0x0000
#define		SUPlv_GPIFWAVE_DIR_WRITE			0x0001
#define		SUPlv_GPIFWAVE_MODE_BURST			0x0000
#define		SUPlv_GPIFWAVE_MODE_WORD			0x0001


//	---------------------------------------------------------------------------
//	Plusذ޺ޗpҰ
//	---------------------------------------------------------------------------
#define     SUP_RANGE_8BIT                  	0x00        //  8ޯ
#define     SUP_RANGE_16BIT                 	0x40        //  16ޯ
#define     SUP_RANGE_32BIT                 	0x80        //  32ޯ
#define     SUP_RANGE_64BIT                 	0xC0        //  64ޯ

#define     SUP_ADRS_LOW_MASK                	0x003F
#define     SUP_ADRS_HIGH_MASK               	0x3FC0
#define     SUP_RANGE_MASK  	              	0x00C0

//	---------------------------------------------------------------------------
//	^錾
//	---------------------------------------------------------------------------
union	UNION_8BYTE	{

	unsigned long long	qword;
	unsigned int		dword[2];
	unsigned short  	word[4];
	unsigned char		byte[8];
};

union	UNION_4BYTE	{

	unsigned int	dword;
	unsigned short  word[2];
	unsigned char	byte[4];
};

union	UNION_2BYTE	{

	unsigned short  word;
	unsigned char	byte[2];
};

//	հèè֐
bool	SUP_Get_BoardInfo( usb_dev_handle *handle, unsigned short sel, unsigned short *id );
bool	SUP_Usb_Config( usb_dev_handle *handle, char *filename, bool mode, bool swap, bool encrypt );
bool	SUP_Usb_Deconfig( usb_dev_handle *handle );
bool	SUP_Suspend( usb_dev_handle *handle, unsigned short mode );
bool	SUP_Get_FPGA_Temp( usb_dev_handle *handle, unsigned short sel, unsigned short *temp );
bool	SUP_I2c_Read( usb_dev_handle *handle, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char *Rd );
bool	SUP_I2c_Write( usb_dev_handle *handle, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char Wd );
bool	SUP_GPIO_Dir( usb_dev_handle *handle, unsigned short port, unsigned short dir );
bool	SUP_GPIO_Read( usb_dev_handle *handle, unsigned short port, unsigned char *Rd );
bool	SUP_GPIO_Write( usb_dev_handle *handle, unsigned short port, unsigned char Wd );
bool	SUP_Reg_Burst_Write( usb_dev_handle *handle, unsigned char adrs, unsigned char length, unsigned char *Wd );
bool	SUP_Reg_WriteExIO2( usb_dev_handle *handle, unsigned char adrs, unsigned char wd );


bool	VIEW_BoardInfo( usb_dev_handle *handle );

//	ؓ]֐
bool	SUP_Data_Write( usb_dev_handle *handle, char *filename, unsigned int length, unsigned char range );
bool	SUP_Data_Read( usb_dev_handle *handle, char *filename, unsigned int length, unsigned char range );

//	ڼ޽֐
bool	SUP_Reg_Write( usb_dev_handle *handle, unsigned short adrs, unsigned char range, unsigned long long wd );
bool	SUP_Reg_Read( usb_dev_handle *handle, unsigned short adrs, unsigned char range, unsigned long long *rd );
bool	SUP_Reg_WriteEx( usb_dev_handle *handle, unsigned short adrs, unsigned char size, unsigned char *wd );
bool	SUP_Reg_ReadEx( usb_dev_handle *handle, unsigned short adrs, unsigned char size, unsigned char *rd );

//	̑
bool	SUP_Mem_Cmd( usb_dev_handle *handle, unsigned char cmd, unsigned char range );

#endif
